/* Object Rexx (message operator is the tilde: ~),

/*
   license:

    ------------------------ Apache Version 2.0 license -------------------------
       Copyright (C) 2001-2006 Rony G. Flatscher

       Licensed under the Apache License, Version 2.0 (the "License");
       you may not use this file except in compliance with the License.
       You may obtain a copy of the License at

           http://www.apache.org/licenses/LICENSE-2.0

       Unless required by applicable law or agreed to in writing, software
       distributed under the License is distributed on an "AS IS" BASIS,
       WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
       See the License for the specific language governing permissions and
       limitations under the License.
    -----------------------------------------------------------------------------
*/
   this works for Java 1.2 or higher only (not employing the EnumerationWrapper), 2003-05-10 */
-- using Object Rexx' SysStemSort(), which may not be available on OS/2

-- system=.bsf4rexx~Class.class~forName("java.lang.System")  -- get the class object
system=bsf.loadClass("java.lang.System")  -- get the class object

properties=system~getProperties     -- get the System properties
enum=properties~propertyNames       -- get an enumeration of the property names
say "enum:" enum "class:" enum~class
key.=0
say copies("=", 70)
do i=1 to 9999 while enum~hasMoreElements       -- loop over enumeration
   key.i=enum~nextElement           -- get next element
end
key.0=i-1                             -- save # of stem array elements
say "key.0="key.0
call sysStemSort "Key.", "A", "I"   -- this was introduced in the Windows version of Object Rexx

do i=1 to key.0
   say "key:" pp(left(key.i, 30)) "value:" pp(properties~getProperty(key.i))
end


::requires BSF.CLS       -- get the Object Rexx support for bsf4rexx

::routine pp   -- "cheap man's pretty print"
  return "[" || arg(1) || "]"

